#include <iostream>
#include <string>
#include <algorithm>
using namespace std;

int np(const string &L,int M,int N) 
{
   if(M>N)
      return 0;
   if(M==N)
      return 1;
    
  if(L[M]==L[N])
 
   return 2 + np(L,M+1,N-1);
   
   return max(np(L,M,N-1),np(L,M+1,N));
}

int np(const string &L) 

{
     return np(L,0,L.length()-1);
}

int main()

{
     string L;
     cin >> L;
     cout << np(L) << endl;
     
     return 0;
}